/* Plugin generated by AMXX-Studio */


#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <ColorChat>

#define PLUGIN "CashTrasfer2"
#define VERSION "1.0"
#define AUTHOR "Nodi"

new choice[33][128];
new amount[33];
new plmenu, tmin, tmax, aonly, wconfirm, ad;


public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_dictionary("cashtransfer2.txt");
	register_cvar("transfer_min", "50");
	register_cvar("transfer_max", "5000");
	register_cvar("transfer_alive_only", "0");
	register_cvar("transfer_require_confirm", "1");
	register_cvar("transfer_ad", "1");
	register_clcmd("say /cashtransfer", "cmd_transfer_handle");
	register_clcmd("Amount", "amount_handle");
	tmin=get_cvar_num("transfer_min");
	tmax=get_cvar_num("transfer_max");
	aonly=get_cvar_num("transfer_alive_only")
	wconfirm=get_cvar_num("transfer_require_confirm");
	ad=get_cvar_num("transfer_ad");
	if(ad) {
		set_task(120.0, "advert", 1234,_,_,"b");
	}
}

public advert() {
	ColorChat(0, RED, "%L", LANG_SERVER, "ADVERTISEMENT");
}

public cmd_transfer_handle(id){
	new back[128], foward[128], quit[128], title[192];
	formatex(back, 127, "%L", id, "MENU_BACK");
	formatex(foward, 127, "%L", id, "MENU_FOWARD");
	formatex(quit, 127, "%L", id, "MENU_EXIT");
	formatex(title,191, "%L", id, "MENU_NAME");
	plmenu=menu_create(title, "plmenu_handle");
	new num=get_playersnum();
	for(new i=1; i<=num; i++){
		new tmpName[128];
		get_user_name(i,tmpName, 127);
		if(is_user_connected(i)&&!is_user_hltv(i)){
			menu_additem(plmenu, tmpName, tmpName);
		}
	}
	menu_setprop(plmenu, MPROP_BACKNAME, back);
	menu_setprop(plmenu, MPROP_NEXTNAME, foward);
	menu_setprop(plmenu, MPROP_EXITNAME, quit);
	menu_display(id, plmenu);
}

public plmenu_handle(id, menu, item){
	if(item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	new acc, data[128], tmpName[128], name[128], callback;
	menu_item_getinfo(menu, item, acc, data, 127, name, 127, callback);
	
	tmpName=data;
	new username[128];
	get_user_name(id, username, 127);
	if(equal(tmpName, username)){
		error(id, 3);
		return PLUGIN_HANDLED;
	}
	choice[id]=tmpName; 
	client_cmd(id, "messagemode Amount");
	return PLUGIN_CONTINUE;
}

public amount_handle(id){
	read_argv(1, amount[id], 6);
	confirm(id);
}

public confirm(id) {
	new pMoney=cs_get_user_money(id);
	new iAmount=str_to_num(amount[id]);
	
	if(iAmount<tmin||iAmount>tmax){
		error(id, 1);
		return PLUGIN_HANDLED;
		
	}
	
	if(iAmount>pMoney) {
		error(id, 2);
		return PLUGIN_HANDLED;
	}
	
	if(wconfirm){
		new title[192], first[64], second[64], quit[64];
		formatex(title, 191, "%L", id, "CONFIRM_TITLE", amount[id], choice[id]);
		formatex(first, 63, "%L", id, "CONFIRM");
		formatex(second, 63, "%L", id, "CANCEL");
		formatex(quit, 63, "%L", id, "MENU_EXIT");
		
		new confirmmenu=menu_create(title, "transfer_handle");
		menu_additem(confirmmenu, first);
		menu_additem(confirmmenu, second);
		menu_setprop(confirmmenu, MPROP_EXITNAME, quit);
		menu_display(id, confirmmenu);
	} else {
		make(id);
	}
	return PLUGIN_CONTINUE;
}

public transfer_handle(id, menu, item){
	if(item == MENU_EXIT){
		error(id, 7);
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	switch(item){
		case 0: {
			make(id);
		}
		
		case 1: {
			error(id, 7);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}
public make(id) {
	new recId=get_user_index(choice[id]);
	new iAmount=str_to_num(amount[id]);
	new pMoney=cs_get_user_money(id);
	new username[128];
	get_user_name(id, username, 127);
	if(aonly){
		if(!is_user_alive(id)) {
			error(id, 4);
			return PLUGIN_HANDLED;}
		if(!is_user_alive(recId)){
			error(id, 5);
			return PLUGIN_HANDLED;}
		}

	if(!is_user_connected(recId)) {
		error(id, 6);
		return PLUGIN_HANDLED;
	}

	if(iAmount>pMoney){
		error(id, 2);
		return PLUGIN_HANDLED;
	}

	new rMoney=(cs_get_user_money(recId)+iAmount)
	new sMoney=(pMoney-iAmount);
	cs_set_user_money(id, sMoney, 1);
	cs_set_user_money(recId, rMoney, 1);
	ColorChat(id, RED, "%L", id, "TRANSFER_SEND", iAmount, choice[id]);
	ColorChat(recId, RED, "%L", id, "TRANSFER_RECEIVED", iAmount, username);
	return PLUGIN_HANDLED;
	
}
		
public error(id, errno){
	switch(errno){
		case 0:{
			return PLUGIN_HANDLED;
		}
		
		case 1:{
			ColorChat(id, RED, "%L", id, "MAX_MIN_ERROR", tmin, tmax);
			return PLUGIN_HANDLED;
		}
		
		case 2:{
			ColorChat(id, RED, "%L", id, "NO_MONEY");
			return PLUGIN_HANDLED;
		}
		
		case 3:{
			ColorChat(id, RED, "%L", id, "CANT_YOURSELF");
			menu_display(id, plmenu);
		}
		
		case 4:{
			ColorChat(id, RED, "%L", id, "UMUST_BE_ALIVE");
			return PLUGIN_HANDLED;
		}
		
		case 5:{
			ColorChat(id, RED, "%L", id, "RECIVER_DEAD");
			return PLUGIN_HANDLED;
		}
		
		case 6:{
			ColorChat(id, RED, "%L", id, "NOT_CONNECTED");
			return PLUGIN_HANDLED;
		}
		
		case 7:{
			ColorChat(id, RED, "%L", id, "CANCELLED");
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_HANDLED;
}
		
